Example 27:
# 乾電池駆動可能なCO2センサ AMS CCS811＋温度・湿度・気圧センサ Bosch BME280

二酸化炭素や有機ガスなどによる室内の空気環境状態を測定するガスセンサ ams製 CCS811と、温度・湿度・気圧を測定する環境センサ Bosch製 BME280を使った、乾電池駆動が可能なワイヤレスCO2センサです。  

## 解決した課題

ガスセンサの課題は、消費電力が大きいことです。  
一例として、一般的なガスセンサにはヒーターが内蔵されており、ヒーターの過熱のために 500mW くらいの電力を消費します。また、適正値が得られるまでの加熱時間も必要です。  
一方、単4電池3本で3か月間の動作をさせようとすると、ガスセンサの消費電力を約 0.3mW 以下にする必要があります。  

## 間欠駆動

本例では、超小型で超低消費電力なガスセンサams製のCCS811を使用します。  
しかし、それでも 20mW～60mW 程度の電力を消費します。また、適正値が得られるまで電源を入れっぱなしにしておく必要があり、0.3mW以下にすることは困難です。  
そこで、本サンプルでは、センサをONしてから測定を開始し、測定値の変化が5%以内となったときの値を測定結果とする方法を用いました。多くの場合、10秒以内に測定を完了し、次の測定まで電源を切った状態にすることが出来ます。  
また、Wi-Fi接続を開始する前に、センサの初期化を開始し、Wi-Fi接続処理中にもセンサを加熱するようにして、駆動時間が短くなるように配慮しました。  
環境センサBME280についても、ドライバbme280.ino内のbme280_stop関数により省エネ待機させました。  

## 制約事項

測定精度と起動後の測定継続時間は、トレードオフの関係になります。本来のセンサの測定精度を得ることは出来ません。  

## 製作に必要なデバイス

* Wi-Fiモジュール ESP-WROOM-02
* CO2センサ AMS CCS811
* 温湿度・気圧センサ BME280
* その他、周辺部品など

## 回路の製作方法

ESP-WROOM-02のIO4（10番ピン）を各センサのI2CのSDAへ、IO5（14番ピン）をI2CのSCLへ接続してください。また、省電力駆動のために使用するCCS811のWAK信号をESP-WROOM-02のIO2（7番ピン）へ、ハードウェアエラー時の復帰用のRST信号をIO0（8番ピン）へ接続します。本CCS811センサを間欠駆動したときに、エラーが発生する場合があったので、自動でリセットするようにしました。

## 動作方法

ソースリスト中の#define部へ無線LANアクセスポイントのSSIDとパスワード（PASS）を設定して下さい。  
また、SLEEP_Pに測定間隔を約10分から60分の範囲内で設定します。初期値 59*60*1000000 は59分です。  

## 製作例

<https://blogs.yahoo.co.jp/bokunimowakaru/55886218.html>

## むすび

CCS811の消費電流が4000μAほどありましたが、ディープスリープ時にCCS811をOFFすることで、平均の消費電流70μA程度（BME280、ESPモジュール、レギュレータ込・実測値）まで下げることが出来、乾電池による長時間の駆動が可能になりました。  
起動後、データが得られるまでに要する時間を考慮すると、ディープスリープの間隔が約3.7分以上のときに省エネ効果があります。約4分以下の間隔で測定したい場合は、CCS811の電源を入れっぱなしにした方が良いでしょう。

Copyright (c) 2017-2019 Wataru KUNINO  
<https://bokunimo.net/>
