Example 28: 
# LCDへ表示する(HTTP版・時刻表示機能・NTP受信機能付き・棒グラフ機能)

ESP-WROOM-02を搭載した ESPduino または WEMOS D1 へ、Arduino 用 LCD Keypad Shield を装着して使用するWi-Fi LCD端末です。  

## ボタン操作

### SELECTボタン

本機のIPアドレスを表示します。また、長押しで棒グラフ表示モードへ切り換えます。

### UP/DOWNボタン

過去に受信した履歴データを表示します。時刻部に「!」が表示されます。履歴表示を解除するときは SELECTボタンを押してください。

### LEFT/RIGHTボタン

受信したデータが表示しきれないときに左右に文字を移動させて内容を確認することが出来ます。

## 製作に必要なデバイス

* ESPduino または WEMOS D1
* Arduino 用 LCD Keypad Shield
* その他、周辺部品など

## 動作方法

ソースリスト中の#define部へ無線LANアクセスポイントのSSIDとパスワード（PASS）を設定して下さい。  
また、マイコンボードに応じて以下のどちらかを選択してください。

    LiquidCrystal lcd(14,15,4,5,12,13);      // ESPduino用
    LiquidCrystal lcd(0,2,4,14,12,13);       // WEMOS D1用

起動時にアクセスポイントへ接続できなかった場合は、本機が無線アクセスポイントとなって動作します。  
詳細な操作はインターネットブラウザから本機にアクセスして設定して下さい。

## ご注意

* リセットもしくは電源を切る前に、ファイル出力をOFFに設定してください（インターネット・ブラウザから設定）
* ログを保存したい場合は、はじめにSPIFFSを初期化する必要があります（インターネット・ブラウザで操作）
* 本機のアクセスポイントモード動作時はブロードキャストの中継が出来ません
** ESP32で使用している IPスタックlwIP(lightweight IP)の仕様です
** 本機でのブロードキャストの送受信は可能です

Copyright (c) 2016-2019 Wataru KUNINO  
<https://bokunimo.net/>
